package cz.muni.fi.unix;

import static org.junit.Assert.*;

import cz.muni.fi.unix.Algebra;
import java.util.Map;
import java.util.TreeMap;
import org.junit.Test;

public class AlgebraTest {
    @Test
    public void factorialOfZero() {
        assertEquals(1L, Algebra.factorial(0L));
    }

    @Test
    public void factorialOfPositiveNumbers() {
        final Map<Long, Long> entries = new TreeMap<Long, Long>() {{
            put( 1L,       1L);
            put( 2L,       2L);
            put( 5L,     120L);
            put(10L, 3628800L);
        }};

        entries.forEach((n, r) ->
                assertEquals(r.longValue(), Algebra.factorial(n)));
    }

    @Test(expected = ArithmeticException.class)
    public void fatorialOfNegativeNumbers() {
        Algebra.factorial(-1);
    }
}
